---------------------------------------------------
-- Export file for user PARUS                    --
---------------------------------------------------

spool VALTURNS_TMPYP.log

prompt
prompt Creating table VALTURNS_TMPYP
prompt =============================
prompt
create global temporary table VALTURNS_TMPYP
(
  DUMMY            VARCHAR2(1),
  RN               NUMBER(17) not null,
  AUTHID           VARCHAR2(30) not null,
  IDENT            NUMBER(17) default 0 not null,
  COMPANY          NUMBER(17),
  JUR_PERS         NUMBER(17),
  DATE_FROM        DATE,
  DATE_TO          DATE,
  BALELEM          NUMBER(17),
  ACCTYPE          NUMBER(17),
  ACCOUNT          NUMBER(17),
  ANALYTIC1        NUMBER(17),
  ANALYTIC2        NUMBER(17),
  ANALYTIC3        NUMBER(17),
  ANALYTIC4        NUMBER(17),
  ANALYTIC5        NUMBER(17),
  BALUNIT          NUMBER(17),
  CURRENCY         NUMBER(17) not null,
  BCURRENCY        NUMBER(17),
  NOMENCLATURE     NUMBER(17) not null,
  NOMEN_PARTNO     VARCHAR2(80),
  NOMEN_INDATE     DATE,
  AGENT            NUMBER(17) not null,
  ACNT_REMN_QUANT  NUMBER(17,3) default 0,
  ACNT_REMN_SUM    NUMBER(17,2) default 0,
  NHAND_REMN_QUANT NUMBER(17,3) default 0,
  NHAND_REMN_SUM   NUMBER(17,2) default 0,
  PRN              NUMBER(17),
  ACNT_NEW_PRICE   NUMBER(17,3)
)
on commit preserve rows;
alter table VALTURNS_TMPYP
  add constraint C_VALTURNS_TMPYP_PK primary key (RN);

prompt
prompt Creating view V_VALTURNS_TMPYP
prompt ==============================
prompt
create or replace view v_valturns_tmpyp
(nrn, sauthid, nident, ncompany, scompany, ddate_from, ddate_to, njur_pers, sjur_pers, nbalunit, sbalunit, nbalelem, sbalelem, nacctype, sacctype, nat_currency, sat_currency, naccount, saccount, nacc_currency, ncurrency, scurrency, nanalytic1, sanalytic1, sanalytic1_name, nanalytic2, sanalytic2, sanalytic2_name, nanalytic3, sanalytic3, sanalytic3_name, nanalytic4, sanalytic4, sanalytic4_name, nanalytic5, sanalytic5, sanalytic5_name, nnomen, snomen, snomen_name, nnomen_crn, nmeas_main, smeas_main, nmeas_alt, smeas_alt, snomen_partno, dnomen_indate, nagent, sagent, sagent_name, nagent_crn, nacnt_remn_quant, nacnt_remn_sum, nprn, nhand_cnt, nhand_sum, nacnt_new_price)
as
select
  TR.RN,                                -- nRN
  TR.AUTHID,                            -- sAUTHID
  TR.IDENT,                             -- nIDENT
  TR.COMPANY,                           -- nCOMPANY
  CM.FULLNAME,                          -- sCOMPANY
  TR.DATE_FROM,                         -- dDATE_FROM
  TR.DATE_TO,                           -- dDATE_TO
  TR.JUR_PERS,                          -- nJUR_PERS
  JU.CODE,                              -- sJUR_PERS
  TR.BALUNIT,                           -- nBALUNIT
  BU.BUNIT_MNEMO,                       -- sBALUNIT
  TR.BALELEM,                           -- nBALELEM
  BE.CODE,                              -- sBALELEM
  TR.ACCTYPE,                           -- nACCTYPE
  T.CODE,                               -- sACCTYPE
  T.CURRENCY,                           -- nAT_CURRENCY
  TC.INTCODE,                           -- sAT_CURRENCY
  TR.ACCOUNT,                           -- nACCOUNT
  AC.ACC_NUMBER,                        -- sACCOUNT
  AC.ACC_CURRENCY,                      -- nACC_CURRENCY
  TR.CURRENCY,                          -- nCURRENCY
  C.INTCODE,                            -- sCURRENCY
  TR.ANALYTIC1,                         -- nANALYTIC1
  AN1.ANL_NUMBER,                       -- sANALYTIC1
  AN1.ANL_NAME,                         -- sANALYTIC1_NAME
  TR.ANALYTIC2,                         -- nANALYTIC2
  AN2.ANL_NUMBER,                       -- sANALYTIC2
  AN2.ANL_NAME,                         -- sANALYTIC2_NAME
  TR.ANALYTIC3,                         -- nANALYTIC3
  AN3.ANL_NUMBER,                       -- sANALYTIC3
  AN3.ANL_NAME,                         -- sANALYTIC3_NAME
  TR.ANALYTIC4,                         -- nANALYTIC4
  AN4.ANL_NUMBER,                       -- sANALYTIC4
  AN4.ANL_NAME,                         -- sANALYTIC4_NAME
  TR.ANALYTIC5,                         -- nANALYTIC5
  AN5.ANL_NUMBER,                       -- sANALYTIC5
  AN5.ANL_NAME,                         -- sANALYTIC5_NAME
  TR.NOMENCLATURE,                      -- nNOMEN
  NM.NOMEN_CODE,                        -- sNOMEN
  NM.NOMEN_NAME,                        -- sNOMEN_NAME
  NM.CRN,                               -- nNOMEN_CRN
  NM.UMEAS_MAIN,                        -- nMEAS_MAIN
  MM.MEAS_MNEMO,                        -- sMEAS_MAIN
  NM.UMEAS_ALT,                         -- nMEAS_ALT
  AM.MEAS_MNEMO,                        -- sMEAS_ALT
  TR.NOMEN_PARTNO,                      -- sNOMEN_PARTNO
  TR.NOMEN_INDATE,                      -- dNOMEN_INDATE
  TR.AGENT,                             -- nAGENT
  AG.AGNABBR,                           -- sAGENT
  AG.AGNNAME,                           -- sAGENT_NAME
  AG.CRN,                               -- nAGENT_CRN
  TR.ACNT_REMN_QUANT,                   -- nACNT_REMN_QUANT
  TR.ACNT_REMN_SUM,                    -- nACNT_REMN_SUM
  tr.prn,
  tr.nhand_remn_quant,
  tr.nhand_remn_sum,
  tr.acnt_new_price
from
  VALTURNS_TMPYP   TR,
  AGNLIST    AG,
  DICNOMNS   NM,
  DICMUNTS   MM,
  DICMUNTS   AM,
  DICACCS    AC,
  DICANLS    AN1,
  DICANLS    AN2,
  DICANLS    AN3,
  DICANLS    AN4,
  DICANLS    AN5,
  DICBUNTS   BU,
  ACCTYPES   T,
  JURPERSONS JU,
  BALELEMENT BE,
  CURNAMES   C,
  CURNAMES   TC,
  COMPANIES  CM
where
      TR.CURRENCY     = C.RN
  and TR.JUR_PERS     = JU.RN(+)
  and TR.BALELEM      = BE.RN(+)
  and TR.ACCOUNT      = AC.RN(+)
  and TR.ANALYTIC1    = AN1.RN(+)
  and TR.ANALYTIC2    = AN2.RN(+)
  and TR.ANALYTIC3    = AN3.RN(+)
  and TR.ANALYTIC4    = AN4.RN(+)
  and TR.ANALYTIC5    = AN5.RN(+)
  and TR.BALUNIT      = BU.RN(+)
  and TR.NOMENCLATURE = NM.RN(+)
  and NM.UMEAS_MAIN   = MM.RN(+)
  and NM.UMEAS_ALT    = AM.RN(+)
  and TR.AGENT        = AG.RN(+)
  and TR.ACCTYPE      = T.RN(+)
  and T.CURRENCY      = TC.RN(+)
  and TR.COMPANY      = CM.RN
/
grant select on V_VALTURNS_TMPYP to PUBLIC;


prompt
prompt Creating procedure P_INTDOCS_CALCDATAYP
prompt =======================================
prompt
CREATE OR REPLACE PROCEDURE P_INTDOCS_CALCDATAYP(nRN in number, ---77773
                                                 nCNT in number,
                                                 nCENA in number,
                                                 nSUMI out number)
as
  nCNT_REMN  number(18,3); ---77773
  nSUMI_REMN number(17,2); ---77773
begin
  begin
    select T.ACNT_REMN_QUANT,
           T.ACNT_REMN_SUM
      into nCNT_REMN,
           nSUMI_REMN
      from VALTURNS_TMPYP T
     where T.RN = nRN;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND(0,nRN,'VALTURNS_TMPYP');
  end; ---77773


  if nvl(nCENA,0) <> 0 then
    --nSUMI := round(nCNT*nCENA,2); ---77773
    if nvl(nCNT_REMN,0) = nvl(nCNT,0) then
      nSUMI := nSUMI_REMN;
    else
      nSUMI := round(nCNT*nCENA,2);
    end if; ---77773
  else
     nSUMI := 0;
  end if;
end;
/
grant execute on P_INTDOCS_CALCDATAYP to PUBLIC;


prompt
prompt Creating procedure P_INTDOCS_FORMDATAYP
prompt =======================================
prompt
CREATE OR REPLACE PROCEDURE P_INTDOCS_FORMDATAYP(nPRN in number,
                                                 nCOMPANY in number,
                                                 sACCOUNT_PRM in varchar2,
                                                 sBALUNIT_PRM in varchar2,
                                                 sNOMENCODE_PRM in varchar2,
                                                 sNOMENNAME_PRM  in varchar2,
                                                 sGROUP_PRM      in varchar2,
                                                 nIDENT out number,
                                                 sEXECUTEMETHOD out varchar2)
as
  nRESULT           number(17);
BEGIN

     delete from valturns_tmpyp;

     for rec in (select * from v_intdocs r where r.nrn = nprn)
     loop

         if rec.sagent_from is null then
            p_exception(0,'      ');
         end if;

         nIDENT := gen_ident;

         P_VALTURNS_CREATE
         (
             nCOMPANY          =>nCOMPANY  --in number,
            ,nIDENT            =>nIDENT --in number,
            ,dDATE_FROM        =>trunc(rec.ddoc_date,'YY')  --in date,
            ,dDATE_TO          =>rec.ddoc_date  --in date,
            ,NIN_BA_PERIOD     =>null
            ,nLY_CORRECT       =>0
            ,sJUR_PERS         =>rec.sjur_pers  --in varchar2,
            ,nJUR_PERS_WCHLD   =>0
            ,nGROUP_JUR_PERS   =>0  --in number,          --     (0 - , 1 - )
            ,sACCTYPE          =>''  --in varchar2,
            ,sBALELEM          =>null  --in varchar2,
            ,sACCOUNT          =>sACCOUNT_PRM  --in varchar2,
            ,nGROUP_BALELEM    =>0  --in number,          --      (0 - , 1 -   , 2 -   )
            ,nGROUP_ACCOUNT    =>0  --in number,          --     (0 - , 1 -   , 2 -   )
            ,sBALUNIT          =>sBALUNIT_PRM  --in varchar2,
            ,nGROUP_BALUNIT    =>0  --in number,          --     (0 - , 1 - )
            ,sCURRENCY         =>null  --in varchar2,
            ,nSAVE_ZERO_LINES  =>0  --in number,          --     (0 - , 1 - )
            ,sAGENT_CATALOG    =>null  --in varchar2,
            ,sAGENT            =>rec.sagent_from  --in varchar2,
            ,sNOMEN_CATALOG    =>null  --in varchar2,
            ,sNOMEN            =>sNOMENCODE_PRM  --in varchar2,
            ,sNOMEN_NAME       =>sNOMENNAME_PRM  --in varchar2,
            ,sPARTNO           =>null  --in varchar2,
            ,nINDATE           =>0  --in number,
            ,dINDATE_FROM      =>null  --in date,
            ,dINDATE_TO        =>null  --in date,
            ,sNOM_GROUP        =>sGROUP_PRM  --in varchar2,
            ,sNOMENCLS         =>null  --in varchar2,
            ,sOKP              =>null  --in varchar2,
            ,sNOMENCLSF        =>null  --in varchar2,
            ,nNOMENCLSF_WCHLD  =>0  --in number,
            ,nCREATE_SPECS     =>0  --in number,          --    (0 -  , 1 - )
            ,nGROUP_ANALYTIC   =>1  --in number,          --      (0 - , 1 - )
            ,nGROUP_ANALYTIC1  =>1  --in number,          --    1 
            ,nGROUP_ANALYTIC2  =>2  --in number,          --    2 
            ,nGROUP_ANALYTIC3  =>3  --in number,          --    3 
            ,nGROUP_ANALYTIC4  =>4  --in number,          --    4 
            ,nGROUP_ANALYTIC5  =>0  --in number,          --    5 
            ,nACCOUNT_BALANCE  =>null  --in number,
            ,sANALYTIC1        =>null  --in varchar2,
            ,sANALYTIC2        =>null  --in varchar2,
            ,sANALYTIC3        =>null  --in varchar2,
            ,sANALYTIC4        =>null  --in varchar2,
            ,sANALYTIC5        =>null  --in varchar2,
            ,nRESULT           =>nRESULT  --out number          --    (0 -  , 1 -  )
          );




         for rec1 in (select tr.*
                      from valturns tr
                      where tr.ident = nident)
         loop
              if nvl(rec1.acnt_res_quant,0) <> 0 or nvl(rec1.acnt_res_sum,0) <> 0 then
                insert into valturns_tmpyp(rn,authid,ident,company,jur_pers,date_from,date_to,balelem,acctype,account,analytic1,analytic2,analytic3,analytic4,analytic5,
                                           balunit,currency,bcurrency,nomenclature,nomen_partno,nomen_indate,agent,acnt_remn_quant,acnt_remn_sum,prn,acnt_new_price)
                values(rec1.rn,rec1.authid,rec1.ident,rec1.company,rec1.jur_pers,rec1.date_from,rec1.date_to,rec1.balelem,rec1.acctype,rec1.account,
                       rec1.analytic1,rec1.analytic2,rec1.analytic3,rec1.analytic4,rec1.analytic5,
                       rec1.balunit,rec1.currency,rec1.bcurrency,rec1.nomenclature,rec1.nomen_partno,rec1.nomen_indate,rec1.agent,rec1.acnt_res_quant,rec1.acnt_res_sum,nPRN,rec1.acnt_new_price);
              end if;
         end loop;
         delete from valturns t
         where t.ident = nident;
     end loop;
     sEXECUTEMETHOD := 'P_INTDOCS_RELOADVIEW';  ---85137 Slepov     


END;
/
grant execute on P_INTDOCS_FORMDATAYP to PUBLIC;


prompt
prompt Creating procedure P_INTDOCS_RELOADVIEW
prompt =======================================
prompt
CREATE OR REPLACE PROCEDURE P_INTDOCS_RELOADVIEW(nRN in number,
                                                 nCOMPANY in number)
as
  nCRN              INTDOCS.CRN%TYPE;
  nJUR_PERS         PKG_STD.tREF;
BEGIN
  /*   */
  P_INTDOCS_EXISTS(nCOMPANY, nRN, nCRN, nJUR_PERS);

end;
/
grant execute on P_INTDOCS_RELOADVIEW to PUBLIC;


prompt
prompt Creating procedure P_VALTURNS_TMPYP_REMN
prompt ========================================
prompt
create or replace procedure P_VALTURNS_TMPYP_REMN
(
  nIDENT               in number
)
as
begin

    for rec in(
      select T.RN, T.ACNT_REMN_QUANT, T.ACNT_REMN_SUM
        from VALTURNS_TMPYP T,
             SELECTLIST     SL
       where SL.IDENT = nIDENT
         and T.RN = SL.DOCUMENT
    )
    loop

      update VALTURNS_TMPYP T
      set
       T.NHAND_REMN_SUM = rec.ACNT_REMN_SUM,
       T.NHAND_REMN_QUANT = rec.ACNT_REMN_QUANT
      where T.RN = rec.rn;
    end loop;

end;
/
grant execute on P_VALTURNS_TMPYP_REMN to PUBLIC;


prompt
prompt Creating procedure P_VALTURNS_TMPYP_UPDATE
prompt ==========================================
prompt
create or replace procedure P_VALTURNS_TMPYP_UPDATE
(
  nRN                in number,
  NHAND_REMN_QUANT   in number,
  NHAND_REMN_SUM     in number
)
as
  nHAND_SUM_CALC       number(15,2);
  nHAND_QUANT_CALC     number(15,3);

  NHAND_REMN_SUM_OLD   number(15,2);
  NHAND_REMN_QUANT_OLD number(15,3);
  nPRICE               number(20,5);
begin

    begin
      select T.ACNT_NEW_PRICE, T.NHAND_REMN_SUM, T.NHAND_REMN_QUANT
        into nPRICE, NHAND_REMN_SUM_OLD, NHAND_REMN_QUANT_OLD
        from VALTURNS_TMPYP T
       where T.RN = nRN;
    exception
      when NO_DATA_FOUND then
        nPRICE := 0;
    end;

    nHAND_QUANT_CALC := NHAND_REMN_QUANT;
    P_INTDOCS_CALCDATAYP(nRN, nHAND_QUANT_CALC, nPRICE, nHAND_SUM_CALC);

    if NHAND_REMN_SUM <> NHAND_REMN_SUM_OLD and NHAND_REMN_QUANT = NHAND_REMN_QUANT_OLD then  --  
        nHAND_SUM_CALC := NHAND_REMN_SUM;
        update VALTURNS_TMPYP T
        set
         T.NHAND_REMN_SUM = nHAND_SUM_CALC
        where T.RN = nRN;
    else
        update VALTURNS_TMPYP T
        set
         T.NHAND_REMN_SUM = nHAND_SUM_CALC,
         T.NHAND_REMN_QUANT = nHAND_QUANT_CALC
        where T.RN = nRN;
    end if;




end;
/
grant execute on P_VALTURNS_TMPYP_UPDATE to PUBLIC;



spool off
